/**
  *  \file client/dlg-receiver.h
  *
  *  (c) 2001-2007 Stefan Reuther <Streu@gmx.de>
  *
  *  This program is free software; you can redistribute it and/or
  *  modify it under the terms of file `COPYING' that comes with the
  *  source code.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  */
#ifndef PCC_V2_CLIENT_DLG_RECEIVER_H
#define PCC_V2_CLIENT_DLG_RECEIVER_H

#include "ui/ui.h"
#include "game/player.h"
#include "cpluslib/sigslot.h"

class WReceiverSelector : public UIWidget {
    GPlayerSet  receivers;
    bool        mdown : 1;
 public:
    WReceiverSelector(int id);
    ~WReceiverSelector();

    void        toggleUniversal();
    void        setUniversal();

    void        setReceivers(GPlayerSet set);
    GPlayerSet  getReceivers() const { return receivers; }

    void        draw(GfxCanvas& can, UpdateInfo& ui);
    void        getLayoutInfo(LayoutInfo& li);
    bool        handleEvent(const UIEvent& event, bool second_pass);

    Signal0  sig_receiver_changed;

    enum StandardDialogResult {
        sdr_Cancel,
        sdr_Revise,
        sdr_Send
    };
    StandardDialogResult doStandardDialog(int num_revisable);
    bool                 doSimpleDialog(string_t title);
};

#endif
